/++
Модуль, определяющий класс $(LINK2 #Объект, Объект), представляющий 3D-объект в сцене.
+/
module ddd.ddd_object;

import std.stdio;
//import derelict.opengl.gl;
import ddd.dvigimyi_object, ddd.mesh, ddd.material; //, material;
import ddd.zavisimost.graphika_gl;

/++
Класс, представляющий 3D-объект в сцене. Состоит из связки $(LINK2 mesh.html#Меш, меша) 
(или одного из его потомков) и $(LINK2 material.html#Материал, материала), применённого к нему.
+/
public class Объект : ДвижимыйОбъект {
    
    protected Меш меш;
    protected Материал материал;

    /++
    Конструктор, принимающий имя объекта и существующий $(LINK2 mesh.html#Меш, Меш).

    Создаёт материал по-умолчанию.
    +/
    public this(string имя, Меш меш0) {
        super(имя);
        
        меш = меш0;
        //mTexture=0;
        материал = new Материал();
    }

    /++
    Функция, присваивающая объекту переданный $(LINK2 mesh.html#Меш, Меш).
    +/
    public void новый_меш(Меш меш0){
        меш = меш0;
    }
    
    /++
    Вывод этого 3D-объекта на экран.
    +/
    override public void рисовать(){
        материал.рисовать();
        //writeln("Рисуем меш");

        меш.рисовать();
        
    }
    
    /++
    Функция, дающая доступ к материалу объекта. 

    Получив ссылку на материал с помощью этой функции, можно задать его параметры цвета и/или текстуры.
    +/
    public @property Материал получить_материал() {
        return материал;
    }
    
    /// Возвращает количество граней в этом 3D-объекте.
    override public int количество_граней(){
        return меш.количество_граней();
    }
}
