/++
Модуль, представляющий класс $(LINK2 #ДвижимыйОбъект, ДвижимыйОбъект) - 
родительский класс для всех 3D-объектов, которые можно присоединять в контейнер
класса $(LINK2 mesto.html#Место, Место). Это меши, лампы, камеры и т.д.
+/
module ddd.dvigimyi_object;

import ddd.mesto;

/++
Родительский класс для всех 3D-объектов, которые можно присоединять в контейнер
класса $(LINK2 mesto.html#Место, Место). Это меши, лампы, камеры и т.д.


Это абстрактный класс, т.е. его экземпляры создавать нельзя.
+/
public class ДвижимыйОбъект {

    protected Место родитель_ = null;
    protected string имя;

    /// Конструктор, принимающий на вход имя
    public this(string имя0){
        имя = имя0;
    }

    /// Получение имени объекта
    public @property string получить_имя(){
        return имя;
    }


    /// Получение объекта $(LINK2 mesto.html#Место, Места), в контейнер которого входит этот объект
    public @property Место родитель(){
        return родитель_;
    }

    /// Вставка этого объекта в контейнер переданного $(LINK2 mesto.html#Место, Места)
    public void задать_родителя(Место место){
        родитель_ = место;
    }

    /// Вывести этот объект на экран
    abstract public void рисовать();

    /// Количество граней в этом объекте. Всегда возвращает 0.
    public @property int количество_граней(){
        return 0;
    }
    
}
