/++
Модуль, определяющий кортеж настроек для параметров окна программы по-умолчанию. 
Также определяется константа с именем файла, в котором требуется разместить настройки конкретного приложения.
+/
module ddd.nastroyki_ddd;

import my_utils.nastroyki_struct;
//import std.meta: AliasSeq;

/++
Кортеж настроек для параметров окна программы.

Здесь определяются типы параметров и их значения по-умолчанию.
Формат кортежа смотрите в документации к модулю $(B my_utils.nastroyki_struct).

+/
alias Кортеж_Настроек0 = AliasSeq!( 
//  Тип             наименование    значение по-умолчанию
    long[],         "размеры_окна", "[800, 600]",
    string,         "общий_уровень","\"Информация\"",
    string,         "имя_окна",     "\"Тест DDD\"",
    long,           "полный_экран", "0",
    long,           "синхронизация_экрана", "0",
    long,           "режим_desktop", "1"
);


/++
Имя файла $(B настройки_ddd.cfg), в котором требуется разместить настройки конкретного приложения, 
переопределяющие настройки, заданные по-умолчанию в кортеже $(LINK2 #Кортеж_Настроек0, Кортеж_Настроек0).
+/
enum ИМЯ_ФАЙЛА_С_НАСТРОЙКАМИ_DDD = "настройки_ddd.cfg";

Настройки!Кортеж_Настроек0 настройки;

