/++
Модуль, определяющий несколько вспомогательных структур.
+/
module ddd.types;

import std.string;

/++
Структура параметров окна, используемая при его инициализации.
+/
struct ПараметрыОкна {
    /// Ширина окна в пикселях
    int ширина_окна;
    /// Высота окна в пикселях
    int высота_окна;
    /++
    Требуется ли раскрывать окно программы на весь экран,
    0 - оконное приложение, 1 - на весь экран
    +/
    uint флаг_полный_экран;
    /// Требуется ли синхронизация отображения с частотой кадров экрана
	int флаг_синхронизация;
    /++
    Если включен $(B флаг_полный_экран) и этот параметр равен 1, будет задействован "режим Desktop",
    т.е. останется обычный режим экрана системы, но для программы будет задействована вся площадь экрана.

    Не используется, если не включен $(B флаг_полный_экран).
    +/
    int режим_desktop;
    /// Заголовок окна программы.
    string имя_окна; 
    uint ID_окна;
};

/++
Структура, используемая для передачи пары чисел, обычно это либо
координаты (x и y), либо размеры (ширина и высота) чего либо (например, окна).
+/
struct Координаты2D(T) {
    /// Первое число из пары
    T x;
    /// Второе число из пары
    T y;

    @property string ширина_и_высота() {
        return format("ширина = %s, высота = %s", x, y);
    } 

    @property string x_и_y() { //@property 
        return format("x = %s, y = %s", x, y);
    } 

}

