module ddd.zavisimost.sobytija_SDL2;

import std.string;
public import derelict.sdl2.sdl; 

import ddd.okno; //, ddd.zavisimost.okno_SDL2;
import my_utils.journal;

private enum имя_модуля = "события";


   
class ОбработчикСобытий {
    protected bool delegate(SDL_Event e) [SDL_EventType]         функция1; //функции обработки всех событий
    protected bool delegate(SDL_Event e) [SDL_EventType][int]    функция2; //функции дополнительной обработки событий с параметром
    
    this() {
        _регистратор_функций1();
        _регистратор_функций2();
    }
    
    protected void _регистратор_функций1() {
        зарегистрировать_функцию1(SDL_QUIT, &обработка_выхода);
        зарегистрировать_функцию1(SDL_KEYUP, &обработка_отжатия_клавиши);
        зарегистрировать_функцию1(SDL_KEYDOWN, &обработка_нажатия_клавиши);
        зарегистрировать_функцию1(SDL_WINDOWEVENT, &обработка_события_окна);
    }

    protected void _регистратор_функций2() {
        функция2[SDL_KEYUP][SDLK_ESCAPE] = &обработка_отжатия_клавиши_ESCAPE;
        //функция2[SDL_KEYDOWN][-1]=&заглушка;
        функция2[SDL_WINDOWEVENT][SDL_WINDOWEVENT_MINIMIZED] = &обработка_минимизации_окна;
        функция2[SDL_WINDOWEVENT][SDL_WINDOWEVENT_EXPOSED] = &обработка_показа_окна;
    }

    bool обработка() {
		return обработка_всех_событий();
	}
    
    /*
    bool obr_event1() {
        SDL_Event e;
        if (SDL_PollEvent(&e))
            return функция1.get(e.type, &заглушка)(e);
            //return функция1.get(e, &заглушка)(e);
        return false;
    }
    */
	
    bool обработка_всех_событий() {
        SDL_Event e;
		bool результат = false; 
        while (SDL_PollEvent(&e))
            результат = результат || функция1.get(e.type, &заглушка)(e);
        return результат; // Если истина - выходим из программы
    }
    
    bool заглушка(SDL_Event e) {
        return false;
    }
    
    bool обработка_отжатия_клавиши(SDL_Event e) {
        debug в_журнал(имя_модуля, УровниЖурнала.Отладка, format("Отжата клавиша с кодом=%s", e.key.keysym.sym));
        return функция2[e.type].get(e.key.keysym.sym, &заглушка)(e);
    }
    
    bool обработка_отжатия_клавиши_ESCAPE(SDL_Event e) {
        в_журнал(имя_модуля, УровниЖурнала.Информация, "Сработала клавиша Esc");
        return true;
    }
    
    bool обработка_нажатия_клавиши(SDL_Event e) {
        debug в_журнал(имя_модуля, УровниЖурнала.Отладка, format("Нажата клавиша с кодом=%s", e.key.keysym.sym));
        //log(log_module, LogUrovni.Info, format("Код клавиши вправо=%s", SDLK_RIGHT));
        return функция2[e.type].get(e.key.keysym.sym, &заглушка)(e);
        //return false;
    }
    
    bool обработка_выхода(SDL_Event e) {
        в_журнал(имя_модуля, УровниЖурнала.Информация, "Окно закрыто пользователем");
        return true;
    }
    
    bool обработка_события_окна(SDL_Event e) {
        debug в_журнал(имя_модуля, УровниЖурнала.Отладка, format("Событие окна №%s", e.window.event));
        return функция2[e.type].get(e.window.event, &заглушка)(e);
    }

    bool обработка_минимизации_окна(SDL_Event e) {
        в_журнал(имя_модуля, УровниЖурнала.Информация, "Окно минимизировано");
        return false;
    }
    
    bool обработка_показа_окна(SDL_Event e) {
        if (!окно_минимизировано()) 
            восстановление_размеров_окна();
        return false;
    }
    
    void зарегистрировать_функцию1(SDL_EventType тип, bool delegate(SDL_Event e) функция) {
        функция1[тип] = функция;
        функция2[тип][-1] = &заглушка;
    }
    
    void разрегистрировать_функцию1(SDL_EventType тип) {
        функция1.remove(тип);
        функция2.remove(тип);
    }
    
    void зарегистрировать_функцию2(SDL_EventType тип, int код_события, bool delegate(SDL_Event e) функция) {
        функция2[тип][код_события] = функция;
    }
    
    void разрегистрировать_функцию2(SDL_EventType тип, int код_события) {
        if (тип in функция2)
            функция2[тип].remove(код_события);
    }
}
